﻿var 短信发送插件 = (function (_super) {
    __extends(短信发送插件, _super);
    function 短信发送插件() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    短信发送插件.prototype.execute = function () {
        // Get setings
        var commandSettings = this.CommandParam;
        var AppID = this.evaluateFormula(commandSettings.ExtractAppID);
        var AppKey = this.evaluateFormula(commandSettings.ExtractAppKey);
        var TplID = this.evaluateFormula(commandSettings.ExtractTplID);
        var Sign = this.evaluateFormula(commandSettings.ExtractSign);
        var CountryCode = this.evaluateFormula(commandSettings.ExtractCountryCode);
        var TelephoneNum = this.evaluateFormula(commandSettings.ExtractTelephoneNum).toString();
        var Param = this.evaluateFormula(commandSettings.ExtractSMSparameters);

        // Add command logic here
        
        var strRand = randomPassword(10);
        var strTime = Date.parse(new Date()) / 1000;
        var sig = SHA256("appkey=" + AppKey + "&random=" + strRand + "&time=" + strTime + "&mobile=" + TelephoneNum);
        //var password = randomPassword(6);

        var arrParam;
        if (typeof Param !== "undefined") {
            Param = Param.toString();
            arrParam = Param.split("$");
        } else {
            arrParam = [];
        }
        
        if (typeof TelephoneNum === "number") {
            TelephoneNum = TelephoneNum.toString();
        }

        var arrTelephoneNum = TelephoneNum.split(",");
        var arrTel = [];
        
        $.each(arrTelephoneNum, function (index, value) {
            var jsonTel = {};
            jsonTel.mobile = value;
            jsonTel.nationcode = CountryCode === null ? "86" : CountryCode;
            arrTel.push(jsonTel);
        })
        if (Sign === null) {
            Sign = "";
        }

        var data = {
            "ext": "",
            "extend": "",
            "params": arrParam,
            "sig": sig,
            "sign": Sign,
            "tel": arrTel,
            "time": strTime,
            "tpl_id": TplID
        };

        var newData = JSON.stringify(data);


        $.ajax({
            type: "post",
            url: "https://yun.tim.qq.com/v5/tlssmssvr/sendmultisms2?sdkappid=" + AppID + "&random=" + strRand,
            async: false, // 使用同步方式  
            // 1 需要使用JSON.stringify 否则格式为 a=2&b=3&now=14...  
            // 2 需要强制类型转换，否则格式为 {"a":"2","b":"3"}  
            data: newData,
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (data) {
                if (data.errmsg === "OK") {
                    alert("短信发送成功");
                } else {
                    alert("短信发送失败");
                    console.log(data);
                }
            }
        }); 
    };

    return 短信发送插件;
}(Forguncy.CommandBase));

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.CommandFactory.registerCommand("短信发送插件.短信发送插件, 短信发送插件", 短信发送插件);